Unit SFG4R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF66R_p;

procedure SFG4R1(GAMSER :Real; var A :Real; X :Real;
                var GLN :Real; EPS :Real; ITMAX :Integer;
                var IERR :Integer);

implementation

procedure SFG4R1(GAMSER :Real; var A :Real; X :Real;
                var GLN :Real; EPS :Real; ITMAX :Integer;
                var IERR :Integer);
var
N :Integer;
AP,SUM,DEL :Real;
label
_10,_20,_30,_40;
begin
SF66R(A,GLN,IERR);
if ( X > 0.0 ) 
 then goto _10;
GAMSER := 0.0;
goto _40;
_10:
AP := A;
SUM := 1.0/A;
DEL := SUM;
for N:=1 to ITMAX do
 begin
  AP := AP+1.0;
  DEL := DEL*X/AP;
  SUM := SUM+DEL;
  if ( Abs(DEL) < Abs(SUM)*EPS ) 
   then goto _30;
_20:
 end;
IERR := 67;
goto _40;
_30:
GAMSER := SUM*Exp(-X+A*Ln(X)-GLN);
_40:
end;

end.
