Unit SFG4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SFG4R1_p, SFG4R2_p, UTSF10_p;

function SFG4R(var A :Real; X :Real; EPS :Real;
                ITMAX :Integer; var IERR :Integer): Real;

implementation

function SFG4R(var A :Real; X :Real; EPS :Real;
                ITMAX :Integer; var IERR :Integer): Real;
var
SFG4R,GAMSER,GLN,GAMCFR :Real;
const
SYS053 :Real = 3.4E38;
label
_10,_20,_30,_40,_50;
begin
{ Result -    SFG4R  FORTRANe }
IERR := 0;
if ( X >= 0.0 ) 
 then goto _10;
IERR := 65;
goto _40;
_10:
if ( A > 0.0 ) 
 then goto _20;
IERR := 66;
goto _40;
_20:
if ( X >= A+1.0 ) 
 then goto _30;
SFG4R1(GAMSER,A,X,GLN,EPS,ITMAX,IERR);
if ( IERR <> 0 ) 
 then goto _40;
Result := GAMSER;
goto _50;
_30:
SFG4R2(GAMCFR,A,X,GLN,EPS,ITMAX,IERR);
if ( IERR <> 0 ) 
 then goto _40;
Result := 1.0-GAMCFR;
goto _50;
_40:
Result := SYS053;
UTSF10(IERR,34);
_50:
exit;
end;

end.
